// TestMfcDll.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "TestMfcDll.h"
#include <LoadMemoryDll.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// The one and only application object

CWinApp theApp;

using namespace std;

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	// initialize MFC and print and error on failure
	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		// TODO: change error code to suit your needs
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		nRetCode = 1;
	}
	else
	{
		// TODO: code your application's behavior here.
		
		FILE *fp = fopen("MfcDll.dll","rb");
		if(!fp)
			return nRetCode;
		
		fseek(fp,0,SEEK_END);
		ULONG fSize = ::ftell(fp);
		fseek(fp,0,SEEK_SET);
		
		UCHAR *lpDllRawData = new UCHAR[fSize];
		fread(lpDllRawData,fSize,1,fp);
		fclose(fp);
		
		HMODULE hLib = DD_LoadLibrary(lpDllRawData,GetModuleHandle(0));
		if(!hLib)
		{
			MessageBox(NULL,_T("Load dll failed!"),_T(""),0);

			delete[] lpDllRawData;
			return nRetCode;
		}
		else
		{
			delete[] lpDllRawData;

			void (*fTestFun)(LPCSTR);
			*(FARPROC*)&fTestFun = DD_GetProcAddress(hLib, "TestFun");
			if(fTestFun)
				fTestFun("Hello World!");
			
			DD_FreeLibrary(hLib);
		}		
	}

	return nRetCode;
}


